﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridGroupCalcSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraGrid1.DisplayLayout.Bands[0].CardView = true;
            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.ultraGrid1.InitializeRow += UltraGrid1_InitializeRow;
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Columns.Add("Calculated", "Total");
        }

        private void UltraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Cells.Exists("Calculated"))
            {
                e.Row.Cells["Calculated"].Value = (double)e.Row.Cells["Salary"].Value + (double)e.Row.Cells["Score"].Value;
            }
        }

        private void CreateList()
        {
            ObservableCollection<Employee> employeeList = new ObservableCollection<Employee>()
                {
                   new Employee("John Smith", 5250.50, 20, new DateTime(2008,01,01)),
                   new Employee("Hania Dillard", 932874.22, 0, new DateTime(2012,03,17)),
                   new Employee("Devin Burgess", 6944.10, -10, new DateTime(2016,03,22)),
                   new Employee("Arisha Woodcock", 57449.10, 15, new DateTime(2018,11,09)),
                   new Employee("Celia Hogg", 123.50, -3, new DateTime(2011,09,11)),
                   new Employee("Payton Carr", 656749.50, 4, new DateTime(2014,12,26)),
                   new Employee("Angela Mclaughlin", 4894.50, 12, new DateTime(2005,06,30)),
                   new Employee("Ailsa Curtis", 5587.50, -23, new DateTime(2013,11,21)),
                   new Employee("Oscar Hubbard", 3745.50, -17, new DateTime(1986,09,29)),
                   new Employee("Naeem Hall", 54892.50, 10, new DateTime(1993,02,17)),
                   new Employee("Kaeden Vasquez", 56868.50, 3, new DateTime(1996,12,10)),
                   new Employee("Branden Gregory", 4974.50, -6, new DateTime(2017,12,10))
                };
            ultraGrid1.DataSource = employeeList;
        }

        class Employee
        {
            public string Name { get; set; }
            public double Salary { get; set; }
            public double Score { get; set; }
            public DateTime StartDate { get; set; }

            public Employee(string name, double salary, int score, DateTime startDate)
            {
                Name = name;
                Salary = salary;
                Score = score;
                StartDate = startDate;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CreateList();
        }
    }
}
